`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   16:07:16 10/01/2014
// Design Name:   LCD_DRIVER
// Module Name:   U:/test_lcd/LCD_DRIVER/LCD_TB.v
// Project Name:  LCD_DRIVER
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: LCD_DRIVER
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module LCD_TB;

	// Inputs
	reg clk;
	reg reset;
	reg btn1;
	reg btn2;
	reg [7:0] switches;

	wire RS;
	wire R_W;
	wire e;
	wire [7:0] JA;

	// Instantiate the Unit Under Test (UUT)
LCD_DRIVER the_tester (
    .clk(clk), 
    .btn1(btn1), 
    .btn2(btn2), 
    .switches(switches), 
    .reset(reset), 
    .RS(RS), 
    .R_W(R_W), 
    .e(e), 
    .JA(JA)
    );


	
	initial clk = 0;
	initial reset = 0;
	always clk = #10 ~clk;
	
	// Test bench
	// Waits for response from the busy signal, but since the
	// JA is not driven, will never progress...
	initial begin
		// Initialize Inputs
		reset = 1;
		btn1 = 0;
		btn2 = 0;
		switches = 0;
		// Wait 100 ns for global reset to finish
		#100;
		reset = 0;
      switches = 8'h41;
		#300000000
		// Add stimulus here
		btn1 = 1;
		#40
		btn1 = 0;
		#600;

	end
	
	//Specify timing constraints as stated in datasheet for 2.7V
   specify 
		specparam e_width = 450, rw_rs_setup = 60, rw_rs_hold = 20, d_setup = 195, d_hold = 10,
			e_period = 1000;
		$width(posedge e, e_width);
		$period(posedge e, e_period);
		$setup(R_W, posedge e, rw_rs_setup);
		$setup(RS, posedge e, rw_rs_setup);
		$setup(JA, posedge e, d_setup);
		$hold(posedge e, R_W, rw_rs_hold);
		$hold(posedge e, RS, rw_rs_hold);
		$hold(posedge e, JA, d_hold);
	endspecify
	
	
endmodule

